#--------------------------------------------------------------------------------------------------------
# XCN-LowRateChecker [XCN-L.R.C] 2.1.1 by M4rc3L-XCN
# Require: Eventscripts 2.0 +
#--------------------------------------------------------------------------------------------------------

import es,playerlib,gamethread,popuplib,os,string,esamlib,re,sys,psyco
psyco.full()
info = es.AddonInfo() 
info['name']        = "XCN-L.R.C" 
info['version']     = "2.1.1" 
info['author']      = "M4rc3L-XCN"
info['url']         = "http://addons.eventscripts.com/addons/view/XCN-Lowratechecker" 
info['description'] = "Kicked the players from the server if they have LowRates or Fakepings. You can change the Mode of the Script." 

global XCN_LowRateChecker,lrc_checktime,xcn_lrc_playerwarn,xcn_lrc_playerkicks
XCN_LowRateChecker = "2.1.1"
xcn_lrc_playerwarn = []
xcn_lrc_playerkicks = []
def readcfg():
    pfad = str(es.getAddonPath('xcn_lrc')) + '/settings.txt'
    if os.path.isfile(pfad):
      cfgfile = open(pfad, 'r')
      cfglines = map(string.strip, cfgfile.readlines())
      cfgfile.close()
      for line in cfglines:
        if not line.startswith('//'):
          if not line.startswith('#'):
            splittedtarray = line.split(' ', 1)
            variable = splittedtarray[0]
            value = splittedtarray[1]
            es.set(variable,value)

def check_update_available():
  global XCN_LowRateChecker
  update_available = esamlib.getAddon('XCN-Lowratechecker')
  new_version = update_available.currentversion
  if not new_version == XCN_LowRateChecker:
    es.msg("#multi", "#green[XCN-L.R.C]#default Update is available!!! New version is: %s" %new_version)

def es_map_start(ev):
  readcfg()
  gamethread.cancelDelayed("xcn_lrc_timer_element")
  gamethread.delayedname(5,"xcn_lrc_timer_element",lrc_checkrates)
  gamethread.delayed(7,check_update_available)
  global lrc_checktime
  lrc_checktime = int(es.ServerVar("xcnlrc_checktime")) / 5

def player_spawn(ev):
  global xcn_lrc_playerstore
  spawningteam = es.getplayerteam(ev["userid"])
  if spawningteam == 0:
    player = playerlib.getPlayer(ev["userid"])
    if player.isbot == 0:
      playerlang = player.language 
      if playerlang == "german":
        es.tell(ev["userid"],"#multi", "#green[XCN-L.R.C]#default Dieser Server ist gesch\xc3\xbctzt gegen LowRates!")
      else:
        es.tell(ev["userid"], "multi", "#green[XCN-L.R.C]#default This Server is protected for LowRates!")

def unload():
  es.msg("#multi", "#green[XCN-L.R.C]#default unloaded")
  gamethread.cancelDelayed("xcn_lrc_timer_element")
  es.unregclientcmd('lrc_rates')

def load():
  es.set("M4rc3L-XCN","Scripting")
  es.set("XCN-LowRateChecker",XCN_LowRateChecker)
  es.makepublic("XCN-LowRateChecker")
  es.makepublic("M4rc3L-XCN")
  es.msg("#multi","#green[XCN-L.R.C]#default was loaded!")
  if not os.path.isfile(es.getAddonPath('xcn_lrc') + '/settings.txt'):
    es.msg("#multi", "#green[XCN-L.R.C]#default settings.txt not found!")
    es.server.queuecmd("es_unload xcn_lrc")
  readcfg()
  global lrc_checktime
  lrc_checktime = int(es.ServerVar("xcnlrc_checktime")) / 5
  gamethread.delayedname(5,"xcn_lrc_timer_element",lrc_checkrates)
  es.regclientcmd('lrc_rates','xcn_lrc/regcmd',"RateInfo Popup")


def lrc_checkrates():
  global xcn_lrc_playerkicks,xcn_lrc_playerwarn
  gamethread.delayedname(5,"xcn_lrc_timer_element",lrc_checkrates)
  
  xcn_lrc_playerstore = playerlib.getUseridList('#human')
  for lowrater in xcn_lrc_playerstore:
    lowrater_data = playerlib.getPlayer(lowrater)
    lrd_lang = lowrater_data.language
    lrd_name = lowrater_data.name
    lrd_teamid = lowrater_data.teamid
    lrd_isdead = lowrater_data.isdead
    lrd_steamid = lowrater_data.steamid
    lrd_userid = int(lowrater)
    if lrd_teamid > 0:
      tempcheck = 0
      tempcmd = es.getclientvar (lrd_userid, "cl_cmdrate")
      tempupdate = es.getclientvar (lrd_userid, "cl_updaterate")
      temprate = es.getclientvar (lrd_userid, "rate")
      pattern = re.compile('[0-9]{1,6}')
      tempcmd_neu=pattern.findall(tempcmd)
      tempupdate_neu=pattern.findall(tempupdate)
      temprate_neu=pattern.findall(temprate)
      if len(tempcmd_neu) < 1:
        tempcheck = 1
      else:
        if int(tempcmd_neu[0]) < int(es.ServerVar("xcnlrc_mincmdrate")):
          tempcheck = 1
        elif int(tempcmd_neu[0]) > int(es.ServerVar("xcnlrc_maxcmdrate")):
          tempcheck = 1
              
      if len(tempupdate_neu) < 1:
        tempcheck = 1
      else:
        if int(tempupdate_neu[0]) < int(es.ServerVar("xcnlrc_minupdaterate")):
          tempcheck = 1
        elif int(tempupdate_neu[0]) > int(es.ServerVar("xcnlrc_maxupdaterate")):
          tempcheck = 1
        
      if len(temprate_neu) < 1:
        tempcheck = 1
      else:
        if int(temprate_neu[0]) < int(es.ServerVar("xcnlrc_minrate")):
          tempcheck = 1
        elif int(temprate_neu[0]) > int(es.ServerVar("xcnlrc_maxrate")):
          tempcheck = 1


      
      if tempcheck == 1:
        if lrd_lang == "german":
          kickmsg =  "Bitte setze CL_CMDRATE %s, CL_UPDATERATE %s, RATE %s" % (es.ServerVar("xcnlrc_mincmdrate"),es.ServerVar("xcnlrc_minupdaterate"),es.ServerVar("xcnlrc_minrate"))
        else:
          kickmsg =  "Please set CL_CMDRATE %s, CL_UPDATERATE %s, RATE %s" % (es.ServerVar("xcnlrc_mincmdrate"),es.ServerVar("xcnlrc_minupdaterate"),es.ServerVar("xcnlrc_minrate"))    
        
        # KICK MODE
        if es.ServerVar("xcnlrc_kickmode") == 1: 
          if es.ServerVar("xcnlrc_banplayers") == 1: 
            xcn_lrc_playerkicks.append(lrd_steamid)
            if xcn_lrc_playerkicks.count(lrd_steamid) > es.ServerVar("xcnlrc_banplayers_kicks"):
              old_warning = xcn_lrc_playerkicks.count(lrd_steamid)
              while old_warning > 0:
                old_warning = old_warning - 1
                xcn_lrc_playerkicks.remove(lrd_steamid)
              bantime =  es.ServerVar("xcnlrc_banplayers_time")
              es.server.queuecmd("es banid %s %s 1" % (bantime,lrd_steamid))
              es.server.queuecmd("es kickid %s You are Banned for Lowrates!" % lrd_userid)
              es.msg("#multi", "#green[XCN-L.R.C]#default Player #lightgreen%s#green (%s %s %s)#default was banned!" % (lrd_name,tempcmd_neu[0],tempupdate_neu[0],temprate_neu[0]))
            else:
              es.server.cmd('kickid %s %s' % (lrd_userid,kickmsg))
              es.msg("#multi", "#green[XCN-L.R.C]#default Player #lightgreen%s#green (%s %s %s)#default was kicked!" % (lrd_name,tempcmd_neu[0],tempupdate_neu[0],temprate_neu[0]))
          else:
            es.server.cmd('kickid %s %s' % (lrd_userid,kickmsg))
            es.msg("#multi", "#green[XCN-L.R.C]#default Player #lightgreen%s#green (%s %s %s)#default was kicked!" % (lrd_name,tempcmd_neu[0],tempupdate_neu[0],temprate_neu[0]))    
        
        # KICK AND WARN  
        elif es.ServerVar("xcnlrc_kickmode") == 2:
          if es.ServerVar("xcnlrc_spectator") == 1:
            if not lrd_teamid == 1:
              if lrd_isdead == 0:
                es.sexec(lrd_userid, "kill")
              es.changeteam(lrd_userid,'1')
          if es.ServerVar("xcnlrc_changename") == 1:
            if not lrd_name.startswith(str(es.ServerVar("xcn_lrc_changename_name"))):
              es.cexec(lrd_userid,"name %s %s" %(es.ServerVar("xcn_lrc_changename_name"),lrd_name))
          if lrc_checktime > 0:
            xcn_lrc_playerwarn.append(lrd_userid)
            
            if lrd_lang == "german":
              lrc_menu = "[XCN-L.R.C]\n \nBitte setze die folgenden Rates:\n \n CL_CMDRATE        %s\n CL_UPDATERATE  %s\n RATE                     %s\n \n \nDeine momentanen Rates:\n \n CL_CMDRATE        %s\n CL_UPDATERATE  %s\n RATE                     %s" % (es.ServerVar("xcnlrc_mincmdrate"),es.ServerVar("xcnlrc_minupdaterate"),es.ServerVar("xcnlrc_minrate"),tempcmd_neu[0],tempupdate_neu[0],temprate_neu[0])
              es.tell(lrd_userid,"#multi","#green[XCN-L.R.C]#default wechsel deine Rates!")
            else:
              lrc_menu = "[XCN-L.R.C]\n \nPlease Set the following Rates:\n \n CL_CMDRATE        %s\n CL_UPDATERATE  %s\n RATE                     %s\n \n \nYour current Rates:\n \n CL_CMDRATE        %s\n CL_UPDATERATE  %s\n RATE                     %s" % (es.ServerVar("xcnlrc_mincmdrate"),es.ServerVar("xcnlrc_minupdaterate"),es.ServerVar("xcnlrc_minrate"),tempcmd_neu[0],tempupdate_neu[0],temprate_neu[0])
              es.tell(lrd_userid,"#multi","#green[XCN-L.R.C]#default Change your Rates!")
            es.menu(3,lrd_userid,lrc_menu)
                      
            if xcn_lrc_playerwarn.count(lrd_userid) >= lrc_checktime:
              old_warning = xcn_lrc_playerwarn.count(lrd_userid)
              while old_warning > 0:
                old_warning = old_warning - 1
                xcn_lrc_playerwarn.remove(lrd_userid)     
              if es.ServerVar("xcnlrc_banplayers") == 1:
                xcn_lrc_playerkicks.append(lrd_steamid)
                if xcn_lrc_playerkicks.count(lrd_steamid) >= es.ServerVar("xcnlrc_banplayers_kicks"):
                  old_warning = xcn_lrc_playerkicks.count(lrd_steamid)
                  while old_warning > 0:
                    old_warning = old_warning - 1
                    xcn_lrc_playerkicks.remove(lrd_steamid)   
                  bantime =  es.ServerVar("xcnlrc_banplayers_time")
                  es.server.queuecmd("es banid %s %s 1" % (bantime,lrd_steamid))
                  kickmsg ="You are Banned for Lowrates!"
                  es.server.cmd('kickid %s %s' % (lrd_userid,kickmsg))
                  es.msg("#multi", "#green[XCN-L.R.C]#default Player #lightgreen%s#green (%s %s %s)#default was banned!" % (lrd_name,tempcmd_neu[0],tempupdate_neu[0],temprate_neu[0]))
                else:
                  es.server.cmd('kickid %s %s' % (lrd_userid,kickmsg))
                  es.msg("#multi", "#green[XCN-L.R.C]#default Player #lightgreen%s#green (%s %s %s)#default was kicked!" % (lrd_name,tempcmd_neu[0],tempupdate_neu[0],temprate_neu[0]))
              else:
                es.server.cmd('kickid %s %s' % (lrd_userid,kickmsg))
                es.msg("#multi", "#green[XCN-L.R.C]#default Player #lightgreen%s#green (%s %s %s)#default was kicked!" % (lrd_name,tempcmd_neu[0],tempupdate_neu[0],temprate_neu[0]))
              
               

        # ONLY WARN
        elif es.ServerVar("xcnlrc_kickmode") == 3:
          if es.ServerVar("xcnlrc_spectator") == 1:
            if not lrd_teamid == 1:
              if lrd_isdead == 0:
                es.sexec(lrd_userid, "kill")
              es.changeteam(lrd_userid,'1')
          if es.ServerVar("xcnlrc_changename") == 1:
            if not lrd_name.startswith(str(es.ServerVar("xcn_lrc_changename_name"))):
              es.cexec(lrd_userid,"name %s %s" %(es.ServerVar("xcn_lrc_changename_name"),lrd_name))     
          if lrd_lang == "german":
            lrc_menu = "[XCN-L.R.C]\n \nBitte setze die folgenden Rates:\n \n CL_CMDRATE        %s\n CL_UPDATERATE  %s\n RATE                     %s\n \n \nDeine momentanen Rates:\n \n CL_CMDRATE        %s\n CL_UPDATERATE  %s\n RATE                     %s" % (es.ServerVar("xcnlrc_mincmdrate"),es.ServerVar("xcnlrc_minupdaterate"),es.ServerVar("xcnlrc_minrate"),tempcmd_neu[0],tempupdate_neu[0],temprate_neu[0])
            es.tell(lrd_userid,"#multi","#green[XCN-L.R.C]#default wechsel deine Rates!")
          else:
            lrc_menu = "[XCN-L.R.C]\n \nPlease Set the following Rates:\n \n CL_CMDRATE        %s\n CL_UPDATERATE  %s\n RATE                     %s\n \n \nYour current Rates:\n \n CL_CMDRATE        %s\n CL_UPDATERATE  %s\n RATE                     %s" % (es.ServerVar("xcnlrc_mincmdrate"),es.ServerVar("xcnlrc_minupdaterate"),es.ServerVar("xcnlrc_minrate"),tempcmd_neu[0],tempupdate_neu[0],temprate_neu[0])
            es.tell(lrd_userid,"#multi","#green[XCN-L.R.C]#default Change your Rates!")
          es.menu(3,lrd_userid,lrc_menu)

# Rateinfo           
def infopopup(userid):
  if es.ServerVar("xcnlrc_view_rateinfo") == 1:
    global nutpopup_main
    lrc_rates = popuplib.create('lrc_rates')
    lrc_rates.addline('[XCN-L.R.C] Rate Info')
    lrc_rates.addline(' ')
    lrc_rates.addline('Username  | CMD | UPD | RATE')
    lrc_rates.addline(' ')
    xcn_lrc_rateinfo = playerlib.getUseridList('#human')
    es.cexec(userid,"echo ")
    es.cexec(userid,"echo ")
    es.cexec(userid,"echo ")
    es.cexec(userid,"echo ")
    es.cexec(userid,"echo ")
    es.cexec(userid,"echo --------------------------------------------------")
    es.cexec(userid,"echo             XCN-L.R.C Rate Info")
    es.cexec(userid,"echo ")
    es.cexec(userid,"echo User | cl_cmdrate | cl_updaterate | rate")
    es.cexec(userid,"echo --------------------------------------------------")
    for raterinfo in xcn_lrc_rateinfo:
      ratername = es.getplayername(raterinfo)
      cmd = es.getclientvar (raterinfo, "cl_cmdrate")
      update = es.getclientvar (raterinfo, "cl_updaterate")
      rate = es.getclientvar (raterinfo, "rate")
      lrc_rates.addline('%s | %s | %s | %s' %(ratername,cmd,update,rate))
      es.cexec(userid,"echo %s | %s | %s | %s" %(ratername,cmd,update,rate))
    es.cexec(userid,"echo --------------------------------------------------")
    es.cexec(userid,"echo ")
    es.cexec(userid,"echo ")
    popuplib.send('lrc_rates', userid)
    gamethread.delayed(10,lrc_rates.unsend,userid)
    lrc_rates.delete()
  
def player_say(ev):
  if ev['text'] == "#rates":
    infopopup(ev["userid"])
    
def regcmd():
    rcuserid=es.getcmduserid()
    infopopup(rcuserid)
    
  
  
  
  
  
  